/* compile.h
	P.Chongstitvatana

	6 Jan 2004   project som-c
	7 Nov 2005	 project som-v16
	30 Dec 2005	 som-v17
	14 Oct 2009  som-v5     for democracy !
	10 Nov 2012	 som-v52
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "icname.h"

#define PRIVATE			static

#define NAMELEN			32
#define MAXLBUF			1000

/* memory map  for tx-code  CS is vcode struct

  M[ system | --> DS   |  cell ]
            ^          ^       ^
           MAXSYS    MAXDS   MAXMEM

  SS[MAXSS]

  CS[MAXCS]

   system area  1 .. MAXSYS-1
   1..63 local
   256..380 som-string area (124 words)
   390..700 small constants -10..300

*/
#define MAXMEM			500000	// total memory
#define MAXCS			100000	// code segment
#define MAXDS           400000	// data segment
#define MAXSYS			1000	// interface C-som
#define MAXSS			5000	// stack size

// type of identifier in symbol table
#define tyNEW			10
#define tyFUNC			6
#define tyLOCAL			7
#define tyGVAR			8
#define tyENUM			9
#define tyMAC			11	// macro
#define tyFULL			12	// full macro
#define tyNUM			13

// denote gvar arg for DS relocation
#define VSCALAR			0
#define VARRAY			1
#define VSTRING			2

#define NL_CHAR			10
#define EOF_CHAR		255

#define MARK			1	// marker in ystack stmt.c
#define BMARK			2	// break marker
#define NIL				0

// atom in parse tree
#define SP				0   // special
#define OPER			1   // operators
#define NUM				2   // number
#define GNAME			3	// global name
#define LNAME			4	// local name
#define	CNAME			5	// class name
#define STRING			6   // string
#define ADS				7	// pointer

#define RETVAL			64	// global for return value
#define OBJ_SOM51		5678951	// magic cookie

#define som_src 		110
#define som_lst 		150
#define som_obj 		200
#define MODE_ADS 		101

// tokey type
#define tkIDEN		14
#define tkNUMBER 	15
#define tkSTRING 	16
#define tkEOF 		17
#define tkERROR		18

// token value
#define tkSTAR		50
#define tkSLASH 	51
#define tkMINUS 	52
#define tkPLUS 		53
#define tkEQ 		54
#define tkEQEQ		55
#define	tkAND 		56
#define tkBAR 		57
#define tkCARET 	58
#define tkMOD 		59
#define tkNOT 		60
#define tkNE 		61
#define tkLT 		62
#define tkLE		63
#define	tkLTLT 		64
#define tkGT 		65
#define tkGE 		66
#define tkGTGT 		67
#define tkCOLON 	68
#define tkLPAREN	69
#define tkRPAREN	70
#define	tkLBRACKET 	71
#define tkRBRACKET 	72
#define tkBB 		73
#define tkBE 		74
#define tkTO 		75
#define tkIF 		76
#define tkELSE		77
#define	tkWHILE 	78
#define tkFOR 		79
#define tkBREAK 	80
#define tkARRAY 	81
#define tkCASE 		82
#define tkENUM 		83
#define tkSYSCALL	84

// for interp.c

#define	  FALSE		0
#define   FUDGE     16   // scratch area + 3  to chk stkovf
#define   MAXFILE	20

// -------

#define  eqs(a,b)  (strcmp(a,b) == 0)
#define  nl()		printf("\n")

typedef int word;
typedef unsigned char uchar;

extern  char tokstring[];	/* current token string */
extern  int tok;			/* current token */
//extern  uchar CH;			/* current char */
extern  int M[];			/* data, code, cell */
extern  int DS;				/* free data pointer */
extern  int CP;				// code pointer
extern  int SS[];			// stack segment
extern  int *CS;			// code segment in M[.]

extern int fp,sp;
extern int noi;
extern FILE *FI, *FO;

/* function prototypes */

void seterror( char *mess );	// som.c
void error(char *mess);
void warning( char *s, char *mess);
//void loadfile( char *fn );

void strpack(int s1, char *s2);		// string func
void strunpack(char *s1, int s2);
void prstr(int i);

//void eval(int a);					// interp.c
int xalloc(int a);
void initfile(void);
void xsys(int id, int a, int b);

int loadObj(void);					// vm.c
int readNum(void);
int eval(int ip);
int encode(int op, int c, int a);
